#pragma once
#include <math.h>
#include <numbers>
#include <iostream>
#include <string>
#include <mutex>

using namespace std;

//const auto p = 3.14159265358979353;

class Pepravka
{
	double x, y, z;
	int poet;
	mutex mtx;
public:
	Pepravka()
	{
		x = 0;
		y = 0; 
		z = 1;
		poet = 0;
	}
	void pijmi(double gama1, double gama2)
	{
		auto costheta = 2 * gama1 - 1;
		auto sintheta = sqrt(1 - costheta * costheta);
		auto f = 2 * numbers::pi_v<double> * gama2;
	    lock_guard<std::mutex> zmek(mtx);
		x = sintheta * sin(f);                         // !
		y = sintheta * cos(f);
		z = costheta;
		poet++;                                        // !
	}
	void kontrola()
	{
		auto odchylka = (x * x + y * y + z * z - 1);
		if (odchylka > 1e-11)
		{
			cout << "Konme pro nekonzistenci dat po " << poet << " dodvkch" << endl;
			abort();
		}
	}

	string data()
	{
		lock_guard<std::mutex> zmek(mtx);
		//kontrola();                                    // !
		return "("s + to_string(x) + ", "s + to_string(y) + ", "s + to_string(z) + ")"s;
	}
};

extern Pepravka pepravka;

