#ifndef __EITEL_H__
#define __EITEL_H__

#include <stdexcept>
#include <iostream>
#include <string>
using namespace std;

namespace dmy
{

	class eitel
	{

	public:
		// Konstruktor tdy eitel
		// Vytvo instanci eitele pro zadan poet dam
		eitel(int poetDam)
		{
			if (poetDam < 4) throw runtime_error("Poet dam mus bt vt ne 3");
			n = poetDam;
			een = new int[poetDam];
			for (int i = 0; i < n; i++)
			{
				een[i] = -1;
			}
		}

		// Vrt posledn nalezen een. Tuto metodu je teba volat po voln
		// metody NajdiDaleen() nebo NajdiDaleenOddky(), jestlie
		// toto voln vrt true.

		int* geteen()
		{
			return een;
		}

		// Vrt poet dosud nalezench een lohy N dam
		int getPoetNalezencheen()
		{
			return poetNalezencheen;
		}

		// Vrt poet voln metody bezpen()
		// tedy poet testovanch polek achovnice; slou jako mra
		// sloitosti lohy
		long getPoetVoln()
		{
			return poetVoln;
		}

		// Najde dal een lohy N dam
		// Vrt true, jestlie se dal een podailo najt,
		// jinak vrt false
		bool najdiDaleen()
		{
			int* vsledek = poetNalezencheen == 0 ? eOdSloupce(0) : eOdSloupce(n - 1);
			if (vsledek != nullptr)
			{
				poetNalezencheen++;
			}
			return vsledek != nullptr;
		}

		// Projde ostupn vechna existujc een
		// vsledkem je, e datov sloka poetNalezencheen
		// obsahuje poet een lohy
		void najdiVechnaeen()
		{
			while (najdiDaleen())
				;
		}

		// Projde postupn vechna existujc een,
		// kde je dma v prvnm sloupci umstna v zadan dce.
		// Vsledkem je, e datov sloka
		// poetNalezencheen obsahuje poet takovchto een.
		void najdiVechnaeenOddky(int dka)
		{
			while (najdiDaleenOddky(dka))
				;
		}

		// Najde dal een lohy N dam, kde je dma v prvnm
		// sloupci umstna v zadan dce.
		// Parametrem je dka, na n je umstna prvn dma
		// Vrt true, jestlie se dal een podailo najt,
		// jinak vrt false
		bool najdiDaleenOddky(int dka)
		{
			if (een[0] == -1) een[0] = dka;
			int* vsledek = poetNalezencheen == 0 ? eOdSloupce(1) : eOdSloupce(n - 1);
			if (vsledek != nullptr && een[0] == dka)
			{
				poetNalezencheen++;
			}
			return vsledek != nullptr && een[0] == dka;
		}

		// Vype posledn nalezen een
		void vpis()
		{
			cout << "(";
			for (int i = 0; i < n; i++)
			{
				cout << (i == 0 ? "" : ", ") << een[i];
			}
			cout << ")" << endl;
			/* string vsledek = "(";
			for (int i = 0; i < n; i++)
			{
				vsledek.append(i == 0 ? "" : ", ").append(to_string(een[i]));
			}
			vsledek.append(")\n");
			cout << vsledek;*/
		}


	private:
		// Test, zda je dan polko bezpen
		// Vrt true, kdy lze dmu na dan polko postavit a nen ohroena,
		// false v opanm ppad
		bool bezpen(int dka, int sloupec)
		{
			poetVoln++;
			if (sloupec == 0)
			{
				return true;    // V prvnm sloupci lze umstit kamkoli
			}
			bool vsledek = true;
			int j = 0;
			while (vsledek && (j < sloupec))         // Projdi vechny pedchoz sloupce
			{
				vsledek = (een[j] != dka) &&      // stejn dka?
					(een[sloupec - j - 1] != dka - j - 1) && // stejn diagonla?
					(een[sloupec - j - 1] != dka + j + 1);
				if (!vsledek)
				{
					return false;
				}
				j++;
			}
			return true;
		}

		// Najde dal mon umstn v danm sloupci, zane za danou dkou
		// Vrt slo dky, kam lze umstit dmu; je - li rovno N (poet dam),
		// nepodailo se bezpenou dku najt
		int najdiDalBezpenoudku(int dka, int sloupec)
		{

			while (++dka < n)
			{
				if (bezpen(dka, sloupec))
				{
					break;
				}
			}
			return dka;                           // Neuspje-li, vrt N
		}

		// Zane hledat dal een ponaje danm sloupcem
		// Vrt pole obsahujc dal een, pokud existuje,
		// jinak vrt nullptr
		int* eOdSloupce(int sloupec)
		{
			int k;
			while (sloupec > -1)
			{
				k = najdiDalBezpenoudku(een[sloupec], sloupec);
				if (k < n)
				{
					een[sloupec++] = k;
					if (sloupec == n) return een;
				}
				else een[sloupec--] = -1;
			}
			return nullptr;
		}

		int n;
		int* een;
		int poetNalezencheen = 0;
		long poetVoln = 0;
	};
}

#endif // __EITEL_H__